	list	p=16F84
	#include p16F84.inc
;(1) LE MOT DE CONFIGURATION
; POUR LE PIC16F628
;ASM	__CONFIG  _XT_OSC&_WDT_OFF&_LVP_OFF	
;	REGISTRES REG_16F628 ; POUR LE PIC16F628
; POUR LE PIC16F84
	__CONFIG  _XT_OSC&_WDT_OFF
MOTEUR	EQU	H'0020'
MOT1	EQU	H'0021'
MOT2	EQU	H'0022'
ETAT1	EQU	H'0023'
ETAT2	EQU	H'0024'
SENS	EQU	H'0025'
ORDRE	EQU	H'0026'
OCTET	EQU	H'0027'
J	EQU	H'0028'
I	EQU	H'0029'
VARIF	EQU	H'002A'
OPER_1	EQU	H'002B'
OPER_2	EQU	H'002C'
RESULT	EQU	H'002D'
RESTE	EQU	H'002E'
VBFOR1	EQU	H'002F'
;(2) TIQUETTES ET VARIABLES
BR_REC	EQU 2
	ORG 0
;(3) INITIALISATION
;	CMCON=7	; POUR LE 628 UNIQUEMENT
	BSF STATUS, RP0
	MOVLW	H'04'
	MOVWF	TRISA
	BCF STATUS, RP0
	BSF STATUS, RP0
	MOVLW	H'00'
	MOVWF	TRISB
	BCF STATUS, RP0
	MOVLW	H'00'
	MOVWF	MOTEUR
	MOVLW	H'00'
	MOVWF	ETAT1
	MOVLW	H'00'
	MOVWF	ETAT2
	MOVLW	H'06'
	MOVWF	MOT1
	MOVLW	H'06'
	MOVWF	MOT2
; (4) LA BOUCLE DU PROGRAMME PRINCIPAL 	
; RECEPTION DES 3 CARACTRES
DEB	CALL	REC
	MOVF	OCTET,0
	SUBLW	H'4D'
	BTFSC	STATUS,Z
	GOTO	ELSE1
	GOTO	DEB
ELSE1	NOP
	CALL	REC
	MOVF	OCTET,0
	SUBLW	H'31'
	BTFSS	STATUS,Z
	GOTO	ELSE2
	MOVLW	H'01'
	MOVWF	MOTEUR
	GOTO	ENDIF2
ELSE2	NOP
	MOVF	OCTET,0
	SUBLW	H'32'
	BTFSS	STATUS,Z
	GOTO	ELSE3
	MOVLW	H'02'
	MOVWF	MOTEUR
	GOTO	ENDIF3
ELSE3	NOP
	GOTO	DEB
ENDIF3	NOP
ENDIF2	NOP
	CALL	REC
	MOVF	OCTET,0
	SUBLW	H'44'
	BTFSS	STATUS,Z
	GOTO	ELSE4
	MOVLW	H'01'
	MOVWF	SENS
	GOTO	ENDIF4
ELSE4	NOP
	MOVF	OCTET,0
	SUBLW	H'47'
	BTFSS	STATUS,Z
	GOTO	ELSE5
	MOVLW	H'FF'
	MOVWF	SENS
	GOTO	ENDIF5
ELSE5	NOP
	GOTO	DEB
ENDIF5	NOP
ENDIF4	NOP
; (5) TRAITEMENT ET ACTION
	MOVF	MOTEUR,0
	SUBLW	H'01'
	BTFSS	STATUS,Z
	GOTO	ELSE6
	MOVF	ETAT1,0
	ADDWF	SENS,0
	MOVWF	ETAT1
	MOVF	ETAT1,0
	ANDLW	H'03'
	MOVWF	ETAT1
	MOVF	ETAT1,0
	CALL	SEQ
	MOVWF	MOT1
ELSE6	NOP
	MOVF	MOTEUR,0
	SUBLW	H'02'
	BTFSS	STATUS,Z
	GOTO	ELSE7
	MOVF	ETAT2,0
	ADDWF	SENS,0
	MOVWF	ETAT2
	MOVF	ETAT2,0
	ANDLW	H'03'
	MOVWF	ETAT2
	MOVF	ETAT2,0
	CALL	SEQ
	MOVWF	MOT2
ELSE7	NOP
	CLRF	RESULT
	MOVF	MOT2,0
	MOVWF	OPER_1
	MOVLW	H'10'
	MOVWF	OPER_2
	CALL	MUL_OP
	MOVF	RESULT, 0
	MOVWF	ORDRE
	MOVF	ORDRE,0
	ADDWF	MOT1,0
	MOVWF	PORTB
	MOVLW	H'00'
	MOVWF	MOTEUR
	GOTO	DEB
; (6) SQUENCE DES IMPULSIONS SUR LES MOTEURS PAS  PAS	
SEQ	ADDWF	PCL, 1
	RETLW	H'06'
	RETLW	H'05'
	RETLW	H'09'
	RETLW	H'0A'
;(7) SOUS-PROGRAMME DE RECEPTION
REC	CLRF OCTET
ATTREC	BTFSC PORTA,BR_REC
	GOTO	ATTREC
	CALL	PAUSE1250
	MOVLW	H'01'
	MOVWF	J
	SUBLW	H'08'
	MOVWF	VBFOR1
	INCF	VBFOR1,1
SP_FOR1	NOP
	BCF STATUS,C
	BTFSC PORTA,BR_REC
	BSF STATUS,C
	RRF OCTET,1
	CALL	PAUSE833
	INCF	J,1
	DECFSZ	VBFOR1,1
	GOTO	SP_FOR1
	RETURN
;(8) SOUS-PROGRAMME D'ATTENTE DE 1250 MICROSEC 
PAUSE1250	MOVLW	H'F9'
	MOVWF	I
SP1250	NOP
	NOP
	DECFSZ I,1
	GOTO	SP1250
	RETURN
;(9) SOUS-PROGRAMME D'ATTENTE DE 833 MICROSEC 
PAUSE833	MOVLW	H'CE'
	MOVWF	I
SP833	NOP
	DECFSZ I,1
	GOTO	SP833
	RETURN
MUL_OP	BTFSC STATUS, Z
	RETURN
	MOVF	OPER_1, 0
	ADDWF	RESULT, 1
	DECF	OPER_2, 1
	GOTO	MUL_OP
	NOP
	END
